import subprocess

def prepend_org(filename,org):
    f = open(filename,"r+")
    text = f.read()
    f.seek(0)
    f.write((".org $%04X\n" % org) + text)
    f.close()

def disassemble(name, address):
    file_in = "src_bin/" + name + ".bin"
    file_out = "mod_bin/" + name + ".s"
    subprocess.call("cc65\\bin\\da65 -o %s -v -g -S $%04X %s" % (file_out,address,file_in))
    prepend_org(file_out, address)
    

disassemble("00_07",0xF000) # jrlepage

disassemble("01_07",0xF000) # rainwarrior

disassemble("02_00",0x8000) # ipi REDO
disassemble("02_01",0x9000)
disassemble("02_12",0xF000)

disassemble("03_00",0x8000) # tq
disassemble("03_07",0xF000)

disassemble("04_07",0xF000) # doxic

disassemble("05_00",0x8000) # commandycan
disassemble("05_01",0x9000)
disassemble("05_0E",0xF000)

disassemble("06_00",0x8000) # hertz
disassemble("06_01",0x9000)
disassemble("06_10",0xF000)

disassemble("07_07",0xF000) # jangler

disassemble("08_00",0x8000) # tristendo REDO
disassemble("08_01",0x9000)
disassemble("08_1B",0xF000)

disassemble("09_00",0x8000) # kfaraday
disassemble("09_01",0x9000)
disassemble("09_0D",0xF000)

disassemble("0A_07",0xF000) # stinkbug

disassemble("0B_00",0x8000) # gyms
disassemble("0B_01",0x9000)
disassemble("0B_0E",0xF000)

disassemble("0C_07",0xF000) # moot

disassemble("0D_00",0x8000) # FOD
disassemble("0D_01",0x9000)
disassemble("0D_0D",0xF000)

disassemble("0E_00",0xF000) # chipchop
disassemble("0E_07",0xF000)

disassemble("0F_00",0x8000) # zan
disassemble("0F_09",0xF000)

disassemble("10_00",0x8000) # KFF
disassemble("10_01",0x9000)
disassemble("10_02",0xF000)
disassemble("10_03",0xF000)
disassemble("10_04",0xF000)
disassemble("10_05",0xF000)
disassemble("10_06",0xF000)
disassemble("10_07",0xF000)
