.import sta_5FF8, sta_5FF9, sta_5FFA, sta_5FFB, sta_5FFC, sta_5FFD, sta_5FFE, sta_5FFF
.import sty_5FFC, sty_5FFD
.org $8000
; da65 V2.14.0
; Created:    2013-10-27 21:13:51
; Input file: src_bin/08_00.bin
; Page:       1


        .setcpu "6502"

L0004           := $0004
L0006           := $0006
L9058           := $9058
L907C           := $907C
        lsr     $54
        .byte   $44
        .byte   $52
        lsr     $20,x
        .byte   $02
        asl     a
        jmp     L800E

        jmp     L8287

L800E:  asl     a
        jsr     L8088
        lda     #$00
        ldx     #$0B
L8016:  sta     $4000,x
        dex
        bne     L8016
        ldx     #$06
L801E:  sta     $400D,x
        dex
        bne     L801E
        lda     #$30
        sta     $400C
        lda     #$0F
        sta     $4015
        lda     #$08
        sta     $4001
        sta     $4005
        lda     #$C0
        sta     $4017
        lda     #$40
        sta     $4017
        lda     #$FF
        sta     $0209
        sta     $02F3
        sta     $02EF
        lda     #$00
        tax
L804E:  sta     $0241,x
        sta     $02BB,x
        sta     $02BF,x
        sta     $02C7,x
        sta     $02C3,x
        sta     $025E,x
        sta     $025A,x
        inx
        cpx     #$04
        bne     L804E
        lda     $0208
        and     #$02
        beq     L807D
        lda     #$30
        ldx     #$00
L8073:  sta     $02CF,x
        inx
        cpx     #$04
        bne     L8073
        lda     #$00
L807D:  sta     $0245
        ldx     #$04
        lda     #$80
        sta     $0232,x
        rts

L8088:  pha
        lda     $95E7
        sta     L0006
        lda     $95E8
        sta     $07
        ldy     #$00
L8095:  clc
        lda     (L0006),y
        adc     $95E7
        sta     $0200,y
        iny
        lda     (L0006),y
        adc     $95E8
        sta     $0200,y
        iny
        cpy     #$08
        bne     L8095
        lda     (L0006),y
        sta     $0208
        iny
        cpx     #$01
        beq     L80CD
        lda     (L0006),y
        iny
        sta     $0219
        lda     (L0006),y
        iny
        sta     $021A
        lda     #$67
        sta     $0C
        lda     #$93
        sta     $0D
        jmp     L80E3

L80CD:  iny
        iny
        lda     (L0006),y
        iny
        sta     $0219
        lda     (L0006),y
        iny
        sta     $021A
        lda     #$27
        sta     $0C
        lda     #$94
        sta     $0D
L80E3:  pla
        tay
        jsr     L8134
        ldx     #$01
        stx     $0211
        dex
L80EE:  lda     #$7F
        sta     $0237,x
        lda     #$80
        sta     $024B,x
        lda     #$00
        sta     $02D7,x
        sta     $02E3,x
        sta     $02BB,x
        sta     $026A,x
        sta     $0250,x
        sta     $02CB,x
        sta     $0232,x
        inx
        cpx     #$04
        bne     L80EE
        ldx     #$FF
        stx     $0271
        stx     $0272
        lda     #$00
        sta     $02F0
        inx
        stx     $0213
        jsr     L8171
        jsr     L87B7
        lda     #$00
        sta     $0215
        sta     $0216
        rts

L8134:  lda     $0200
        sta     L0004
        lda     $0201
        sta     $05
        clc
        lda     (L0004),y
        adc     $95E7
        sta     L0006
        iny
        lda     (L0004),y
        adc     $95E8
        sta     $07
        lda     #$00
        tax
        tay
        clc
        lda     (L0006),y
        adc     $95E7
        sta     $020A
        iny
        lda     (L0006),y
        adc     $95E8
        sta     $020B
        iny
L8165:  lda     (L0006),y
        sta     $020C,x
        iny
        inx
        cpx     #$06
        bne     L8165
        rts

L8171:  pha
        lda     $0210
        beq     L817A
; MOD        sta     $5FFB
    jsr sta_5FFB
L817A:  pla
        asl     a
        clc
        adc     $020A
        sta     L0004
        lda     #$00
        tay
        tax
        adc     $020B
        sta     $05
        clc
        lda     (L0004),y
        adc     $95E7
        sta     L0006
        iny
        lda     (L0004),y
        adc     $95E8
        sta     $07
        ldy     #$00
        stx     $0212
L81A0:  clc
        lda     (L0006),y
        adc     $95E7
        sta     $0223,x
        iny
        lda     (L0006),y
        adc     $95E8
        sta     $0228,x
        iny
        lda     #$00
        sta     $0250,x
        sta     $023C,x
        lda     #$FF
        sta     $0255,x
        inx
        cpx     #$05
        bne     L81A0
        lda     $0208
        and     #$01
        beq     L81D9
        ldx     #$00
L81CE:  lda     (L0006),y
        sta     $022D,x
        iny
        inx
        cpx     #$05
        bne     L81CE
L81D9:  lda     #$00
        sta     $021E
        sta     $021F
        lda     $0220
        bne     L81E7
        rts

L81E7:  sta     $0212
        ldx     #$00
L81EC:  lda     $0212
        sta     $01
        lda     #$00
        sta     $0250,x
L81F6:  ldy     #$00
        lda     $0223,x
        sta     $0A
        lda     $0228,x
        sta     $0B
L8202:  lda     $0250,x
        beq     L820D
        dec     $0250,x
        jmp     L8226

L820D:  lda     ($0A),y
        bmi     L823E
        lda     $0255,x
        cmp     #$FF
        bne     L8222
        iny
        lda     ($0A),y
        iny
        sta     $0250,x
        jmp     L8226

L8222:  iny
        sta     $0250,x
L8226:  clc
        tya
        adc     $0A
        sta     $0223,x
        lda     #$00
        adc     $0B
        sta     $0228,x
        dec     $01
        bne     L81F6
        inx
        cpx     #$05
        bne     L81EC
        rts

L823E:  cmp     #$80
        beq     L8272
        cmp     #$82
        beq     L825F
        cmp     #$84
        beq     L8269
        pha
        cmp     #$8E
        beq     L825A
        and     #$F0
        cmp     #$F0
        beq     L825A
        cmp     #$E0
        beq     L827C
        iny
L825A:  iny
        pla
        jmp     L8202

L825F:  iny
        lda     ($0A),y
        iny
        sta     $0255,x
        jmp     L8202

L8269:  iny
        lda     #$FF
        sta     $0255,x
        jmp     L8202

L8272:  iny
        lda     ($0A),y
        iny
        jsr     L8DDC
        jmp     L8202

L827C:  iny
        pla
        and     #$0F
        asl     a
        jsr     L8DDC
        jmp     L8202

L8287:  lda     $0211
        bne     L828D
        rts

L828D:  ldx     #$00
L828F:  lda     $023C,x
        beq     L82A7
        sec
        sbc     #$01
        sta     $023C,x
        bne     L82A7
        jsr     L83A2
        lda     $0241,x
        and     #$7F
        sta     $0241,x
L82A7:  inx
        cpx     #$05
        bne     L828F
        lda     $0216
        bmi     L82B9
        ora     $0215
        beq     L82B9
        jmp     L8353

L82B9:  lda     #$00
        sta     $02F1
        lda     $0214
        beq     L82CE
        lda     #$00
        sta     $0214
        lda     $0213
        jsr     L8171
L82CE:  ldx     #$00
L82D0:  lda     $023C,x
        beq     L82DD
        lda     #$00
        sta     $023C,x
        jsr     L83A2
L82DD:  jsr     L83A2
        lda     $0241,x
        and     #$7F
        sta     $0241,x
        inx
        cpx     #$05
        bne     L82D0
        lda     $021E
        beq     L8300
        sec
        sbc     #$01
        sta     $0213
        lda     #$01
        sta     $0214
        jmp     L8350

L8300:  lda     $021F
        beq     L832B
        sec
        sbc     #$01
        sta     $0220
        inc     $0213
        lda     $0213
        cmp     $020C
        beq     L831E
        lda     #$01
        sta     $0214
        jmp     L8350

L831E:  lda     #$00
        sta     $0213
        lda     #$01
        sta     $0214
        jmp     L8350

L832B:  inc     $0212
        lda     $0212
        cmp     $020D
        bne     L8350
        inc     $0213
        lda     $0213
        cmp     $020C
        beq     L8347
        sta     $0214
        jmp     L8350

L8347:  ldx     #$00
        stx     $0213
        inx
        stx     $0214
L8350:  jsr     L87A3
L8353:  sec
        lda     $0215
        sbc     $0217
        sta     $0215
        lda     $0216
        sbc     $0218
        sta     $0216
        ldx     #$00
L8368:  lda     $0241,x
        beq     L8384
        sec
        sbc     #$01
        sta     $0241,x
        bne     L8384
        sta     $0232,x
        sta     $02C7,x
        sta     $02C3,x
        sta     $025E,x
        sta     $025A,x
L8384:  inx
        cpx     #$05
        bne     L8368
        ldx     #$00
L838B:  jsr     L8820
        lda     $0232,x
        beq     L8396
        jsr     L8BB3
L8396:  jsr     L88F1
        inx
        cpx     #$04
        bne     L838B
        jsr     L8FC1
        rts

L83A2:  ldy     $0250,x
        beq     L83AD
        dey
        tya
        sta     $0250,x
        rts

L83AD:  sty     $021C
        lda     $022D,x
        beq     L83B8
; MOD        sta     $5FFB
    jsr sta_5FFB
L83B8:  lda     #$0F
        sta     $021B
        lda     $0223,x
        sta     $0A
        lda     $0228,x
        sta     $0B
L83C7:  lda     ($0A),y
        bpl     L83CE
        jmp     L8497

L83CE:  beq     L8436
        cmp     #$7F
        bne     L83D7
        jmp     L8453

L83D7:  cmp     #$7E
        bne     L83DE
        jmp     L8439

L83DE:  sta     $0232,x
        jsr     L86D3
        lda     $0241,x
        bmi     L83EE
        lda     #$00
        sta     $0241,x
L83EE:  lda     $935D,x
        cmp     #$05
        bne     L83F8
        jmp     L84BF

L83F8:  jsr     L8DCA
        lda     #$00
        sta     $0246,x
        lda     $021B
        sta     $029B,x
        lda     #$00
        lda     $029F,x
        and     #$F0
        sta     $029F,x
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        ora     $029F,x
        sta     $029F,x
        lda     $02BB,x
        cmp     #$06
        beq     L8425
        cmp     #$08
        bne     L842A
L8425:  lda     #$00
        sta     $02BB,x
L842A:  cpx     #$02
        bcc     L8431
        jmp     L84BF

L8431:  lda     #$00
        sta     $026F,x
L8436:  jmp     L84BF

L8439:  lda     #$01
        sta     $0246,x
        lda     $935D,x
        cmp     #$05
        bne     L844D
        lda     #$FF
        sta     $0232,x
        jmp     L84BF

L844D:  jsr     L8D4D
        jmp     L84BF

L8453:  lda     #$00
        sta     $0232,x
        lda     $935D,x
        cmp     #$05
        bne     L8462
        jmp     L84BF

L8462:  lda     #$00
        sta     $029B,x
        sta     $02C7,x
        sta     $02C3,x
        sta     $025E,x
        sta     $025A,x
        cpx     #$02
        bcs     L847C
        lda     #$FF
        sta     $0271,x
L847C:  jmp     L84BF

L847F:  pla
        asl     a
        asl     a
        asl     a
        and     #$78
        sta     $0237,x
        iny
        jmp     L83C7

L848C:  pla
        and     #$0F
        asl     a
        jsr     L8DDC
        iny
        jmp     L83C7

L8497:  pha
        and     #$F0
        cmp     #$F0
        beq     L847F
        cmp     #$E0
        beq     L848C
        pla
        and     #$7F
        sty     $00
        tay
        lda     L84F2,y
        sta     L0006
        iny
        lda     L84F2,y
        sta     $07
        ldy     $00
        iny
        jmp     (L0006)

L84B9:  sta     $0250,x
        jmp     L84CC

L84BF:  lda     $0255,x
        cmp     #$FF
        bne     L84B9
        iny
        lda     ($0A),y
        sta     $0250,x
L84CC:  clc
        iny
        tya
        adc     $0A
        sta     $0223,x
        lda     #$00
        adc     $0B
        sta     $0228,x
        lda     $021C
        beq     L84EB
        sta     $026F,x
        lda     #$00
        sta     $021C
        sta     $0271,x
L84EB:  rts

L84EC:  lda     ($0A),y
        pha
        iny
        pla
        rts

L84F2:  bit     $3585
        sta     $3E
        sta     $46
        sta     $52
        sta     $5E
        sta     $67
        sta     $70
        sta     $7B
        sta     $C4
        sta     $95
        sta     $A3
        sta     $87
        sta     $B1
        sta     $DE
        sta     $03
        stx     $1F
        stx     $28
        stx     $43
        stx     $30
        stx     $D5
        sta     $3A
        stx     $57
        stx     $60
        stx     $6E
        stx     $7C
        stx     $85
        stx     $90
        stx     $A4
        stx     $20
        cpx     $2084
        .byte   $DC
        sta     $C74C
        .byte   $83
        jsr     L84EC
        sta     $0255,x
        jmp     L83C7

        lda     #$FF
        sta     $0255,x
        jmp     L83C7

        jsr     L84EC
        sta     $020E
        jsr     L87B7
        jmp     L83C7

        jsr     L84EC
        sta     $020F
        jsr     L87B7
        jmp     L83C7

        jsr     L84EC
        sta     $021E
        jmp     L83C7

        jsr     L84EC
        sta     $021F
        jmp     L83C7

        jsr     L84EC
        lda     #$00
        sta     $0211
        jmp     L83C7

        jsr     L84EC
        sta     $021B
        sta     $029B,x
        jmp     L83C7

        jsr     L84EC
        sta     $02BF,x
        lda     #$02
        sta     $02BB,x
        jmp     L83C7

        jsr     L84EC
        sta     $02BF,x
        lda     #$03
        sta     $02BB,x
        jmp     L83C7

        jsr     L84EC
        sta     $02BF,x
        lda     #$04
        sta     $02BB,x
        jmp     L83C7

        jsr     L84EC
        sta     $02BF,x
        lda     #$00
        sta     $02CB,x
        lda     #$01
        sta     $02BB,x
        jmp     L83C7

        lda     #$00
        sta     $02BF,x
        sta     $02BB,x
        sta     $02C7,x
        sta     $02C3,x
        jmp     L83C7

        jsr     L84EC
        sta     $021C
        jmp     L83C7

        jsr     L84EC
        pha
        lda     $02D7,x
        bne     L85F3
        lda     $0208
        and     #$02
        beq     L85F0
        lda     #$30
L85F0:  sta     $02CF,x
L85F3:  pla
        pha
        and     #$F0
        sta     $02D3,x
        pla
        and     #$0F
        sta     $02D7,x
        jmp     L83C7

        jsr     L84EC
        pha
        and     #$F0
        sta     $02DF,x
        pla
        and     #$0F
        sta     $02E3,x
        cmp     #$00
        beq     L8619
        jmp     L83C7

L8619:  sta     $02DB,x
        jmp     L83C7

        jsr     L84EC
        sta     $024B,x
        jmp     L83C7

        lda     #$80
        sta     $024B,x
        jmp     L83C7

        jsr     L84EC
        sta     $023C,x
        dey
        jmp     L84CC

        jsr     L84EC
        sta     $02EF
        jmp     L83C7

        jsr     L84EC
        sta     $029F,x
        clc
        asl     a
        asl     a
        asl     a
        asl     a
        ora     $029F,x
        sta     $029F,x
        jmp     L83C7

        jsr     L84EC
        sta     $02F0
        jmp     L83C7

        jsr     L84EC
        sta     $02BF,x
        lda     #$05
        sta     $02BB,x
        jmp     L83C7

        jsr     L84EC
        sta     $02BF,x
        lda     #$07
        sta     $02BB,x
        jmp     L83C7

        jsr     L84EC
        sta     $026A,x
        jmp     L83C7

        jsr     L84EC
        ora     #$80
        sta     $0241,x
        jmp     L83C7

        jsr     L84EC
        sta     $02F1
        lda     $02F2
        bne     L86A1
        lda     $02F1
        sta     $02F2
L86A1:  jmp     L83C7

        jsr     L84EC
        sta     $02F3
        jmp     L83C7

L86AD:  sec
        sbc     #$01
        cpx     #$03
        beq     L86C6
        asl     a
        sty     $00
        tay
L86B8:  lda     ($0C),y
        sta     $025E,x
        iny
        lda     ($0C),y
        sta     $025A,x
        ldy     $00
        rts

L86C6:  and     #$0F
        ora     #$10
        sta     $025E,x
        lda     #$00
        sta     $025A,x
        rts

L86D3:  sec
        sbc     #$01
        pha
        lda     $935D,x
        cmp     #$05
        bne     L86E1
        jmp     L8749

L86E1:  pla
        cpx     #$03
        beq     L8717
        asl     a
        sty     $00
        tay
        lda     $02BB,x
        cmp     #$02
        bne     L8713
        lda     ($0C),y
        sta     $02C7,x
        iny
        lda     ($0C),y
        sta     $02C3,x
        ldy     $00
        lda     $025E,x
        ora     $025A,x
        bne     L8712
        lda     $02C7,x
        sta     $025E,x
        lda     $02C3,x
        sta     $025A,x
L8712:  rts

L8713:  jmp     L86B8

        rts

L8717:  ora     #$10
        pha
        lda     $02BB,x
        cmp     #$02
        bne     L873F
        pla
        sta     $02C7,x
        lda     #$00
        sta     $02C3,x
        lda     $025E,x
        ora     $025A,x
        bne     L873E
        lda     $02C7,x
        sta     $025E,x
        lda     $02C3,x
        sta     $025A,x
L873E:  rts

L873F:  pla
        sta     $025E,x
        lda     #$00
        sta     $025A,x
        rts

L8749:  clc
        pla
        pha
        asl     a
        adc     $0204
        sta     L0004
        lda     #$00
        adc     $0205
        sta     $05
        clc
        pla
        adc     L0004
        sta     L0004
        lda     #$00
        adc     $05
        sta     $05
        sty     $00
        ldy     #$00
        lda     (L0004),y
        sta     $02EE
        iny
        lda     $02EF
        bpl     L877B
        lda     (L0004),y
        bmi     L877B
        sta     $02EF
L877B:  iny
        lda     (L0004),y
        tay
        lda     $0206
        sta     L0004
        lda     $0207
        sta     $05
        lda     (L0004),y
        sta     $02EB
        iny
        lda     (L0004),y
        sta     $02EC
        iny
        lda     (L0004),y
        sta     $02ED
        ldy     $00
        lda     $02F1
        sta     $02F2
        rts

L87A3:  clc
        lda     $0215
        adc     $0219
        sta     $0215
        lda     $0216
        adc     $021A
        sta     $0216
        rts

L87B7:  tya
        pha
        lda     $020F
        sta     $10
        lda     #$00
        sta     $11
        ldy     #$03
L87C4:  asl     $10
        rol     $11
        dey
        bne     L87C4
        lda     $10
        sta     $0E
        lda     $11
        tay
        asl     $10
        rol     $11
        clc
        lda     $0E
        adc     $10
        sta     $0E
        tya
        adc     $11
        sta     $0F
        lda     $020E
        sta     $10
        lda     #$00
        sta     $11
        jsr     L87FB
        lda     $0E
        sta     $0217
        lda     $0F
        sta     $0218
        pla
        tay
        rts

L87FB:  lda     #$00
        sta     $13
        ldy     #$10
L8801:  asl     $0E
        rol     $0F
        rol     a
        rol     $13
        pha
        cmp     $10
        lda     $13
        sbc     $11
        bcc     L8819
        sta     $13
        pla
        sbc     $10
        pha
        inc     $0E
L8819:  pla
        dey
        bne     L8801
        sta     $12
        rts

L8820:  lda     $026A,x
        beq     L884F
        lda     $026A,x
        and     #$0F
        sta     $00
        sec
        lda     $0237,x
        sbc     $00
        bpl     L8836
        lda     #$00
L8836:  sta     $0237,x
        lda     $026A,x
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        sta     $00
        clc
        lda     $0237,x
        adc     $00
        bpl     L884C
        lda     #$7F
L884C:  sta     $0237,x
L884F:  lda     $02BB,x
        beq     L8885
        cmp     #$01
        beq     L8873
        cmp     #$02
        beq     L8876
        cmp     #$03
        beq     L8879
        cmp     #$06
        beq     L887C
        cmp     #$08
        beq     L887F
        cmp     #$05
        beq     L8882
        cmp     #$07
        beq     L8882
        jmp     L89B4

L8873:  jmp     L8A5C

L8876:  jmp     L892E

L8879:  jmp     L89A2

L887C:  jmp     L89FE

L887F:  jmp     L8A24

L8882:  jmp     L8886

L8885:  rts

L8886:  lda     $025E,x
        pha
        lda     $025A,x
        pha
        lda     $02BF,x
        and     #$0F
        sta     $00
        lda     $02BB,x
        cmp     #$05
        beq     L88A5
        lda     $0232,x
        sec
        sbc     $00
        jmp     L88AB

L88A5:  lda     $0232,x
        clc
        adc     $00
L88AB:  sta     $0232,x
        jsr     L86AD
        lda     $025E,x
        sta     $02C7,x
        lda     $025A,x
        sta     $02C3,x
        lda     $02BF,x
        lsr     a
        lsr     a
        lsr     a
        ora     #$01
        sta     $02BF,x
        pla
        sta     $025A,x
        pla
        sta     $025E,x
        clc
        lda     $02BB,x
        adc     #$01
        sta     $02BB,x
        cpx     #$03
        bne     L88EE
        cmp     #$06
        beq     L88E9
        lda     #$06
        sta     $02BB,x
        jmp     L884F

L88E9:  lda     #$08
        sta     $02BB,x
L88EE:  jmp     L884F

L88F1:  lda     $025E,x
        sta     $0262,x
        lda     $025A,x
        sta     $0266,x
        lda     $024B,x
        cmp     #$80
        beq     L8927
        clc
        lda     $0262,x
        adc     #$80
        sta     $0262,x
        lda     $0266,x
        adc     #$00
        sta     $0266,x
        sec
        lda     $0262,x
        sbc     $024B,x
        sta     $0262,x
        lda     $0266,x
        sbc     #$00
        sta     $0266,x
L8927:  jsr     L8AA8
        jsr     L8B75
        rts

L892E:  lda     $02BF,x
        beq     L899F
        lda     $02C7,x
        ora     $02C3,x
        beq     L899F
        lda     $025A,x
        cmp     $02C3,x
        bcc     L8972
        bne     L8952
        lda     $025E,x
        cmp     $02C7,x
        bcc     L8972
        bne     L8952
        jmp     L8885

L8952:  lda     $02BF,x
        sta     L0004
        lda     #$00
        sta     $05
        jsr     L89E2
        cmp     $02C3,x
        bcc     L8993
        bmi     L8993
        bne     L899F
        lda     $025E,x
        cmp     $02C7,x
        bcc     L8993
        jmp     L8885

L8972:  lda     $02BF,x
        sta     L0004
        lda     #$00
        sta     $05
        jsr     L89C6
        lda     $02C3,x
        cmp     $025A,x
        bcc     L8993
        bne     L899F
        lda     $02C7,x
        cmp     $025E,x
        bcc     L8993
        jmp     L8885

L8993:  lda     $02C7,x
        sta     $025E,x
        lda     $02C3,x
        sta     $025A,x
L899F:  jmp     L8885

L89A2:  lda     $02BF,x
        sta     L0004
        lda     #$00
        sta     $05
        jsr     L89E2
        jsr     L8F66
        jmp     L8885

L89B4:  lda     $02BF,x
        sta     L0004
        lda     #$00
        sta     $05
        jsr     L89C6
        jsr     L8F66
        jmp     L8885

L89C6:  clc
        lda     $025E,x
        adc     L0004
        sta     $025E,x
        lda     $025A,x
        adc     $05
        sta     $025A,x
        bcc     L89E1
        lda     #$FF
        sta     $025E,x
        sta     $025A,x
L89E1:  rts

L89E2:  sec
        lda     $025E,x
        sbc     L0004
        sta     $025E,x
        lda     $025A,x
        sbc     $05
        sta     $025A,x
        bcs     L89FD
        lda     #$00
        sta     $025E,x
        sta     $025A,x
L89FD:  rts

L89FE:  sec
        lda     $025E,x
        sbc     $02BF,x
        sta     $025E,x
        lda     $025A,x
        sbc     #$00
        sta     $025A,x
        bmi     L8A48
        cmp     $02C3,x
        bcc     L8A48
        bne     L8A59
        lda     $025E,x
        cmp     $02C7,x
        bcc     L8A48
        jmp     L8885

L8A24:  clc
        lda     $025E,x
        adc     $02BF,x
        sta     $025E,x
        lda     $025A,x
        adc     #$00
        sta     $025A,x
        cmp     $02C3,x
        bcc     L8A59
        bne     L8A48
        lda     $025E,x
        cmp     $02C7,x
        bcs     L8A48
        jmp     L8885

L8A48:  lda     $02C7,x
        sta     $025E,x
        lda     $02C3,x
        sta     $025A,x
        lda     #$00
        sta     $02BB,x
L8A59:  jmp     L8885

L8A5C:  lda     $02CB,x
        cmp     #$01
        beq     L8A73
        cmp     #$02
        beq     L8A94
        lda     $0232,x
        jsr     L86AD
        inc     $02CB,x
        jmp     L8885

L8A73:  lda     $02BF,x
        lsr     a
        lsr     a
        lsr     a
        lsr     a
        clc
        adc     $0232,x
        jsr     L86AD
        lda     $02BF,x
        and     #$0F
        bne     L8A8E
        sta     $02CB,x
        jmp     L8885

L8A8E:  inc     $02CB,x
        jmp     L8885

L8A94:  lda     $02BF,x
        and     #$0F
        clc
        adc     $0232,x
        jsr     L86AD
        lda     #$00
        sta     $02CB,x
        jmp     L8885

L8AA8:  lda     $02D7,x
        bne     L8AAE
        rts

L8AAE:  clc
        adc     $02CF,x
        and     #$3F
        sta     $02CF,x
        cmp     #$10
        bcc     L8AD7
        cmp     #$20
        bcc     L8AE7
        cmp     #$30
        bcc     L8B01
        sec
        sbc     #$30
        sta     $00
        sec
        lda     #$0F
        sbc     $00
        ora     $02D3,x
        tay
        lda     $94E7,y
        jmp     L8B0B

L8AD7:  ora     $02D3,x
        tay
        lda     $94E7,y
        sta     L0004
        lda     #$00
        sta     $05
        jmp     L8B20

L8AE7:  sec
        sbc     #$10
        sta     $00
        sec
        lda     #$0F
        sbc     $00
        ora     $02D3,x
        tay
        lda     $94E7,y
        sta     L0004
        lda     #$00
        sta     $05
        jmp     L8B20

L8B01:  sec
        sbc     #$20
        ora     $02D3,x
        tay
        lda     $94E7,y
L8B0B:  eor     #$FF
        sta     L0004
        lda     #$FF
        sta     $05
        clc
        lda     L0004
        adc     #$01
        sta     L0004
        lda     $05
        adc     #$00
        sta     $05
L8B20:  lda     $0208
        and     #$02
        beq     L8B42
        lda     #$0F
        clc
        adc     $02D3,x
        tay
        clc
        lda     $94E7,y
        adc     #$01
        adc     L0004
        sta     L0004
        lda     $05
        adc     #$00
        sta     $05
        lsr     $05
        ror     L0004
L8B42:  lda     $9362,x
        cmp     #$0A
        beq     L8B63
        cmp     #$04
        beq     L8B63
        cmp     #$06
        beq     L8B63
        sec
        lda     $0262,x
        sbc     L0004
        sta     $0262,x
        lda     $0266,x
        sbc     $05
        sta     $0266,x
        rts

L8B63:  clc
        lda     $0262,x
        adc     L0004
        sta     $0262,x
        lda     $0266,x
        adc     $05
        sta     $0266,x
        rts

L8B75:  lda     $02E3,x
        bne     L8B80
        lda     #$00
        sta     $02E7,x
        rts

L8B80:  clc
        adc     $02DB,x
        and     #$3F
        sta     $02DB,x
        lsr     a
        cmp     #$10
        bcc     L8BA5
        sec
        sbc     #$10
        sta     $00
        sec
        lda     #$0F
        sbc     $00
        ora     $02DF,x
        tay
        lda     $94E7,y
        lsr     a
        sta     $00
        jmp     L8BAF

L8BA5:  ora     $02DF,x
        tay
        lda     $94E7,y
        lsr     a
        sta     $00
L8BAF:  sta     $02E7,x
        rts

L8BB3:  lda     $0277,x
        beq     L8BD2
        sta     $07
        lda     $0273,x
        sta     L0006
        lda     $02A3,x
        cmp     #$FF
        beq     L8BD2
        jsr     L8D00
        sta     $02A3,x
        lda     $0222
        sta     $029B,x
L8BD2:  lda     $027F,x
        beq     L8C52
        sta     $07
        lda     $027B,x
        sta     L0006
        lda     $02A7,x
        cmp     #$FF
        beq     L8C3C
        jsr     L8D00
        sta     $02A7,x
        lda     $0232,x
        beq     L8C52
        ldy     #$03
        lda     (L0006),y
        beq     L8C1E
        cmp     #$01
        beq     L8C15
        clc
        lda     $0232,x
        adc     $0222
        cmp     #$01
        bcc     L8C0D
        cmp     #$5F
        bcc     L8C0F
        lda     #$5F
        bne     L8C0F
L8C0D:  lda     #$01
L8C0F:  sta     $0232,x
        jmp     L8C31

L8C15:  lda     $0222
        clc
        adc     #$01
        jmp     L8C31

L8C1E:  clc
        lda     $0232,x
        adc     $0222
        beq     L8C29
        bpl     L8C2B
L8C29:  lda     #$01
L8C2B:  cmp     #$60
        bcc     L8C31
        lda     #$60
L8C31:  jsr     L86AD
        lda     #$01
        sta     $02B7,x
        jmp     L8C52

L8C3C:  ldy     #$03
        lda     (L0006),y
        beq     L8C52
        lda     $02B7,x
        beq     L8C52
        lda     $0232,x
        jsr     L86AD
        lda     #$00
        sta     $02B7,x
L8C52:  lda     $0287,x
        beq     L8C89
        sta     $07
        lda     $0283,x
        sta     L0006
        lda     $02AB,x
        cmp     #$FF
        beq     L8C89
        jsr     L8D00
        sta     $02AB,x
        clc
        lda     $0222
        adc     $025E,x
        sta     $025E,x
        lda     $0222
        bpl     L8C7E
        lda     #$FF
        bmi     L8C80
L8C7E:  lda     #$00
L8C80:  adc     $025A,x
        sta     $025A,x
        jsr     L8F66
L8C89:  lda     $028F,x
        beq     L8CD3
        sta     $07
        lda     $028B,x
        sta     L0006
        lda     $02AF,x
        cmp     #$FF
        beq     L8CD3
        jsr     L8D00
        sta     $02AF,x
        lda     $0222
        sta     L0004
        rol     a
        bcc     L8CB1
        lda     #$FF
        sta     $05
        jmp     L8CB5

L8CB1:  lda     #$00
        sta     $05
L8CB5:  ldy     #$04
L8CB7:  clc
        rol     L0004
        rol     $05
        dey
        bne     L8CB7
        clc
        lda     L0004
        adc     $025E,x
        sta     $025E,x
        lda     $05
        adc     $025A,x
        sta     $025A,x
        jsr     L8F66
L8CD3:  lda     $0297,x
        beq     L8CFF
        sta     $07
        lda     $0293,x
        sta     L0006
        lda     $02B3,x
        cmp     #$FF
        beq     L8CFF
        jsr     L8D00
        sta     $02B3,x
        lda     $0222
        pha
        lda     $029F,x
        and     #$F0
        sta     $029F,x
        pla
        ora     $029F,x
        sta     $029F,x
L8CFF:  rts

L8D00:  clc
        adc     #$04
        tay
        lda     (L0006),y
        sta     $0222
        dey
        dey
        dey
        tya
        ldy     #$00
        cmp     (L0006),y
        beq     L8D1A
        ldy     #$02
        cmp     (L0006),y
        beq     L8D36
        rts

L8D1A:  iny
        lda     (L0006),y
        cmp     #$FF
        bne     L8D22
        rts

L8D22:  pha
        lda     $0246,x
        bne     L8D2A
        pla
        rts

L8D2A:  ldy     #$02
        lda     (L0006),y
        bne     L8D32
        pla
        rts

L8D32:  pla
        lda     #$FF
        rts

L8D36:  sta     $00
        lda     $0246,x
        bne     L8D4A
        dey
        lda     (L0006),y
        cmp     #$FF
        bne     L8D22
        lda     $00
        sec
        sbc     #$01
        rts

L8D4A:  lda     $00
        rts

L8D4D:  tya
        pha
        lda     $0277,x
        beq     L8D67
        sta     $07
        lda     $0273,x
        sta     L0006
        ldy     #$02
        lda     (L0006),y
        beq     L8D67
        sec
        sbc     #$01
        sta     $02A3,x
L8D67:  lda     $027F,x
        beq     L8D7F
        sta     $07
        lda     $027B,x
        sta     L0006
        ldy     #$02
        lda     (L0006),y
        beq     L8D7F
        sec
        sbc     #$01
        sta     $02A7,x
L8D7F:  lda     $0287,x
        beq     L8D97
        sta     $07
        lda     $0283,x
        sta     L0006
        ldy     #$02
        lda     (L0006),y
        beq     L8D97
        sec
        sbc     #$01
        sta     $02AB,x
L8D97:  lda     $028F,x
        beq     L8DAF
        sta     $07
        lda     $028B,x
        sta     L0006
        ldy     #$02
        lda     (L0006),y
        beq     L8DAF
        sec
        sbc     #$01
        sta     $02AF,x
L8DAF:  lda     $0297,x
        beq     L8DC7
        sta     $07
        lda     $0293,x
        sta     L0006
        ldy     #$02
        lda     (L0006),y
        beq     L8DC7
        sec
        sbc     #$01
        sta     $02B3,x
L8DC7:  pla
        tay
        rts

L8DCA:  lda     #$00
        sta     $02A3,x
        sta     $02A7,x
        sta     $02AB,x
        sta     $02AF,x
        sta     $02B3,x
        rts

L8DDC:  sta     $02
        sty     $00
        ldy     #$00
        clc
        adc     $0202
        sta     L0004
        tya
        adc     $0203
        sta     $05
        clc
        lda     (L0004),y
        adc     $95E7
        sta     L0006
        iny
        lda     (L0004),y
        adc     $95E8
        sta     $07
        lda     $9362,x
        tay
        lda     L8E12,y
        sta     L0004
        iny
        lda     L8E12,y
        sta     $05
        ldy     #$00
        jmp     (L0004)

L8E12:  asl     $1E8E,x
        stx     L8F66
        ror     $8F
        asl     $668E,x
        .byte   $8F
        lda     (L0006),y
        sta     $02
        iny
        ror     $02
        bcc     L8E5B
        clc
        lda     (L0006),y
        adc     $95E7
        sta     L0004
        iny
        lda     (L0006),y
        adc     $95E8
        sta     $05
        iny
        lda     L0004
        cmp     $0273,x
        bne     L8E49
        lda     $05
        cmp     $0277,x
        bne     L8E49
        jmp     L8E63

L8E49:  lda     L0004
        sta     $0273,x
        lda     $05
        sta     $0277,x
        lda     #$00
        sta     $02A3,x
        jmp     L8E63

L8E5B:  lda     #$00
        sta     $0273,x
        sta     $0277,x
L8E63:  ror     $02
        bcc     L8E9B
        clc
        lda     (L0006),y
        adc     $95E7
        sta     L0004
        iny
        lda     (L0006),y
        adc     $95E8
        sta     $05
        iny
        lda     L0004
        cmp     $027B,x
        bne     L8E89
        lda     $05
        cmp     $027F,x
        bne     L8E89
        jmp     L8EA3

L8E89:  lda     L0004
        sta     $027B,x
        lda     $05
        sta     $027F,x
        lda     #$00
        sta     $02A7,x
        jmp     L8EA3

L8E9B:  lda     #$00
        sta     $027B,x
        sta     $027F,x
L8EA3:  ror     $02
        bcc     L8EDB
        clc
        lda     (L0006),y
        adc     $95E7
        sta     L0004
        iny
        lda     (L0006),y
        adc     $95E8
        sta     $05
        iny
        lda     L0004
        cmp     $0283,x
        bne     L8EC9
        lda     $05
        cmp     $0287,x
        bne     L8EC9
        jmp     L8EE3

L8EC9:  lda     L0004
        sta     $0283,x
        lda     $05
        sta     $0287,x
        lda     #$00
        sta     $02AB,x
        jmp     L8EE3

L8EDB:  lda     #$00
        sta     $0283,x
        sta     $0287,x
L8EE3:  ror     $02
        bcc     L8F1B
        clc
        lda     (L0006),y
        adc     $95E7
        sta     L0004
        iny
        lda     (L0006),y
        adc     $95E8
        sta     $05
        iny
        lda     L0004
        cmp     $028B,x
        bne     L8F09
        lda     $05
        cmp     $028F,x
        bne     L8F09
        jmp     L8F23

L8F09:  lda     L0004
        sta     $028B,x
        lda     $05
        sta     $028F,x
        lda     #$00
        sta     $02AF,x
        jmp     L8F23

L8F1B:  lda     #$00
        sta     $028B,x
        sta     $028F,x
L8F23:  ror     $02
        bcc     L8F5B
        clc
        lda     (L0006),y
        adc     $95E7
        sta     L0004
        iny
        lda     (L0006),y
        adc     $95E8
        sta     $05
        iny
        lda     L0004
        cmp     $0293,x
        bne     L8F49
        lda     $05
        cmp     $0297,x
        bne     L8F49
        jmp     L8F63

L8F49:  lda     L0004
        sta     $0293,x
        lda     $05
        sta     $0297,x
        lda     #$00
        sta     $02B3,x
        jmp     L8F63

L8F5B:  lda     #$00
        sta     $0293,x
        sta     $0297,x
L8F63:  ldy     $00
        rts

L8F66:  lda     $9362,x
        tay
        lda     L8F7A,y
        sta     L0004
        iny
        lda     L8F7A,y
        sta     $05
        ldy     #$00
        jmp     (L0004)

L8F7A:  .byte   $87
        .byte   $8F
        ldy     $8F
        stx     $8F
        ldy     $8F
        .byte   $87
        .byte   $8F
        stx     $8F
        rts

        lda     $025A,x
        bmi     L8F9B
        cmp     #$08
        bcc     L8F9A
        lda     #$07
        sta     $025A,x
        lda     #$FF
        sta     $025E,x
L8F9A:  rts

L8F9B:  lda     #$00
        sta     $025E,x
        sta     $025A,x
        rts

        lda     $025A,x
        bmi     L8FB8
        cmp     #$10
        bcc     L8FB7
        lda     #$0F
        sta     $025A,x
        lda     #$FF
        sta     $025E,x
L8FB7:  rts

L8FB8:  lda     #$00
        sta     $025E,x
        sta     $025A,x
        rts

L8FC1:  lda     $0211
        bne     L8FD7
        lda     #$00
        sta     $4015
        rts

        lda     #$C0
        sta     $4017
        lda     #$40
        sta     $4017
        rts

L8FD7:  lda     $0209
        and     #$01
        bne     L8FE1
        jmp     L907C

L8FE1:  lda     $0232
        beq     L9058
        lda     $0237
        asl     a
        beq     L9058
        and     #$F0
        sta     $00
        lda     $029B
        beq     L9058
        ora     $00
        tax
        lda     $925D,x
        sec
        sbc     $02E7
        .byte   $10
