; NSFe

NSF_INIT = $FF00 ; defined in startup.s / startup.cfg
.import nsf_ramcode_play

.segment "NSFE"
.byte "NSFE"

.segment "INFO"
.import __INFO_SIZE__
.dword (__INFO_SIZE__-8)
.byte "INFO"
.word $8000
.word NSF_INIT
.word nsf_ramcode_play
.byte %00000010 ; PAL/NTSC bitfield
.byte %00000000 ; expansions bitfield
.byte 17 ; song count
.byte 0 ; starting song

.segment "BANK"
.import __BANK_SIZE__
.dword (__BANK_SIZE__-8)
.byte "BANK"
.byte 0,0,0,0,0,0,0,$F9

.segment "DCNK"
.import __DCNK_SIZE__
.dword (__DCNK_SIZE__-8)
.byte "DATA"
.incbin "temp/00_7F.bin"
.incbin "temp/80_FE.bin"

.segment "plst"
.import __plst_SIZE__
.dword (__plst_SIZE__-8)
.byte "plst"
.byte 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16

.segment "time"
.import __time_SIZE__
.dword (__time_SIZE__-8)
.byte "time"
.dword (( 3*60)+33)*1000 ; 00
.dword (( 2*60)+22)*1000 ; 01
.dword (( 2*60)+10)*1000 ; 02
.dword (( 3*60)+26)*1000 ; 03
.dword (( 3*60)+44)*1000 ; 04
.dword (( 3*60)+10)*1000 ; 05
.dword (( 8*60)+28)*1000 ; 06
.dword (( 4*60)+11)*1000 ; 07
.dword (( 3*60)+41)*1000 ; 08
.dword (( 3*60)+29)*1000 ; 09
.dword (( 2*60)+07)*1000 ; 10
.dword (( 4*60)+12)*1000 ; 11
.dword (( 2*60)+32)*1000 ; 12
.dword (( 4*60)+25)*1000 ; 13
.dword (( 2*60)+55)*1000 ; 14
.dword (( 4*60)+52)*1000 ; 15
.dword ((11*60)+10)*1000 ; 16

.segment "fade"
.import __fade_SIZE__
.dword (__fade_SIZE__-8)
.byte "fade"
.dword 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.segment "tlbl"
.import __tlbl_SIZE__
.dword (__tlbl_SIZE__-8)
.byte "tlbl"
.asciiz "0. jrlepage - Introduction"
.asciiz "1. bradsmith - dry up and tumble on"
.asciiz "2. ipi - Garten"
.asciiz "3. TQ-Jam - Milky Fields"
.asciiz "4. Doxic - Pollution"
.asciiz "5. commandycan - Sky Bus For Hire"
.asciiz "6. HertzDevil - Extends Levant"
.asciiz "7. Jangler - Tide/Grotto"
.asciiz "8. TristEndo - Be water my friend"
.asciiz "9. kfaraday - The Bloop"
.asciiz "10. stinkbug - Dreamgate"
.asciiz "11. gyms - Magmo's Magical Ingot"
.asciiz "12. Moot Booxl - Ouroboros"
.asciiz "13. Fearofdark - An Earth made of Molten Rock"
.asciiz "14. chipchop - the robot emptiness"
.asciiz "15. Zan-zan-zawa-veia - Dove Dome"
.asciiz "16. KungFuFurby - Null and Void"

.segment "auth"
.import __auth_SIZE__
.dword (__auth_SIZE__-8)
.byte "auth"
.asciiz "2A03 Puritans"       ; title
.asciiz "The Bitpuritans"     ; artist
.asciiz "2013 bitpuritans.eu" ; copyright
.asciiz "rainwarrior"         ; ripper

.segment "text"
.import __text_SIZE__
.dword (__text_SIZE__-8)
.byte "text"
.byte "2A03 Puritans by the Bitpuritans, 2013.",13,10
.byte "http://bitpuritans.eu"
.byte 0

.segment "NEND"
.import __NEND_SIZE__
.dword (__NEND_SIZE__-8)
.byte "NEND"
